#include "usart.h"
#include "device.h"
#include "spi2.h"
#include "ult.h"
#include "socket.h"
#include "w5500.h"
#include "24c16.h"
#include "md5.h"
#include "string.h"

extern uint8 txsize[];										// ⲿSocketͻС
extern uint8 rxsize[];										// ⲿSocketջС

uint8 buffer[2048];												// һ2KB飬Socketͨ

int main(void)
{
  uint8 server_ip[4]={192,168,1,250};			// Զ̷IPַ
	uint16 server_port1=5000;								// Զ̷˿
	uint16 server_port2=6000;								// Զ̷˿
	
  uint16 local_port=6000;									// ʼһض˿
  uint16 len=0;
	
  /***** MCUʱӳʼ *****/							  
	Systick_Init(72);	
	
	/***** жϿ *****/
	NVIC_Configuration();
	
	/***** GPIOSPIʼ *****/
	GPIO_Configuration();			
	WIZ_SPI_Init();
	
	/***** ڳʼ *****/
	USART1_Init(); 		
	
	/***** ʼeeprom *****/
  at24c16_init();
	
	/***** ӲW5500 *****/
	Reset_W5500();
	
	/***** W5500IPϢʼ *****/
	set_default(); 														// ĬMACIPGWSUBDNS
	set_network();														// óʼIPϢӡʼ8Socket
	
	/***** W5500Keepalive *****/
	setkeepalive(0);													//
	
	printf("TCP Server IP: %d.%d.%d.%d \r\n",server_ip[0],server_ip[1],server_ip[2],server_ip[3]);
	printf("W5500 Init Complete!\r\n");
  printf("Start TCP Client Test!\r\n"); 
  
	/*Socket״̬MCUͨSn_SR(0)ֵжSocketӦôں״̬
		Sn_SR״̬
		0x00		SOCK_CLOSED
		0x13		SOCK_INIT
		0x14		SOCK_LISTEN
		0x17		SOCK_ESTABLISHED
		0x1C		SOCK_CLOSE_WAIT
		0x22		SOCK_UDP
	*/
	while(1)																				// Socket״̬
	{	
		int i;
		for(i=0;i<=1;i++)
		{
			switch(getSn_SR(i))														// ȡsocket0״̬
			{
				case SOCK_INIT:															// Socketڳʼ()״̬
					
						printf("Socket%d-1 ",i);
						Delay_ms(500);
				
				if(i==0)
				{
						connect(i, server_ip,server_port1);			// Sn_CRΪCONNECTTCP
				}
						
				else
				{
						connect(i, server_ip,server_port2);			// Sn_CRΪCONNECTTCP
				}
				break;
				case SOCK_ESTABLISHED:											// Socketӽ״̬
					
						printf("Socket%d-2 ",i);
						Delay_ms(500);
				
						if(getSn_IR(i) & Sn_IR_CON)   					
						{
							setSn_IR(i, Sn_IR_CON);								// Sn_IRCONλ1֪ͨW5500ѽ
						}
						// ݻػԳݴλW5500W5500յݺٻظ
						len=getSn_RX_RSR(i);										// len=Socket0ջѽպͱݴС
						if(len>0)
						{
							recv(i,buffer,len);										// W5500ԷݣͨSPI͸MCU
							printf("Socket%d:%s\r\n",i,buffer);							// ڴӡյ
//							send(i,buffer,len);										// յݺٻظݻػ
						}
						// W5500Ӵڷݸͻ˳Իس
						if(USART_RX_STA & 0x8000)								// жϴǷ
						{					   
							len=USART_RX_STA & 0x3fff;						// ȡڽյݵĳ
							send(i,USART_RX_BUF,len);							// W5500ͻ˷
							USART_RX_STA=0;												// ڽ״̬־λ0
							memset(USART_RX_BUF,0,len+1);					// ڽջ0
						}
				break;
				case SOCK_CLOSE_WAIT:												// Socketڵȴر״̬
					
						printf("Socket%d-3 ",i);
						Delay_ms(500);
				
						len=getSn_RX_RSR(i);										// len=Socket0ջѽպͱݴС
						if(len>0)
						{
							recv(i,buffer,len);										// W5500ԷݣͨSPI͸MCU
							printf("%s\r\n",buffer);							// ڴӡյ
							send(i,buffer,len);										// յݺٻظݻػ
						}
						disconnect(i);																// ϿSocket0
				break;
				case SOCK_CLOSED:														// Socketڹر״̬
					
						printf("Socket%d-4 ",i);
						Delay_ms(500);
				
						socket(i,Sn_MR_TCP,local_port++,Sn_MR_ND);		// Socket0ΪTCPʱģʽһض˿
				break;
			}
		}
	}
}


